/* Parameter file for SIMD module */

// Should be moved in a feature file ?
	parameter STKPC_INST_BITS 	 	= 16;
	parameter STKPC_INST_MSB 	 	= STKPC_INST_BITS-1;
	parameter STKPC_WORD_BITS 		= 16;
	parameter STKPC_WORD_MSB 	 	= STKPC_WORD_BITS-1;
	parameter STKPC_HALF_WORD_BITS 	= STKPC_WORD_BITS/2;
	parameter STKPC_ADDR_BITS 	 	= STKPC_WORD_BITS;
	parameter STKPC_ALU_TO_PC_MSB 	= 12;
	parameter STKPC_IMM_MSB 		= STKPC_WORD_BITS-2;
	parameter STKPC_ZERO_16BITS	 	= 16'h0000;
	parameter STKPC_ONES_16BITS	 	= 16'hffff;

	// default increment for the PC
	parameter STKPC_PC_INC 		= 2;
	parameter STKPC_PC_WIDTH	= 13;
	parameter STKPC_PC_MSB 		= STKPC_PC_WIDTH -1;

	//Wishbone defines
	parameter WB_ADR_O_WIDTH 	= 16;
	parameter WB_ADR_O_MSB 		= 15;
	parameter WB_DAT_O_WIDTH	= 16;
	parameter WB_DAT_O_MSB 		= 15;
	parameter WB_SEL_O_WIDTH	= 1;
	parameter WB_SEL_O_MSB 		= 0;
	parameter WB_DAT_I_WIDTH	= 16;
	parameter WB_DAT_I_MSB		= 15;
	parameter WB_DELAY_MSB		= 2;

	//GPIO defines
	parameter GPIO_REG_FILE_WIDTH	= 32;
	parameter GPIO_REG_FILE_MSB		= GPIO_REG_FILE_WIDTH-1;
	
	//Data_Stack
	parameter STKPC_DSTACK_WIDTH 		= 16;
	parameter STKPC_DSTACK_SIZE 		= 32;
	parameter STKPC_DSTACK_MSB 			= STKPC_DSTACK_WIDTH -1;
	parameter STKPC_DSTACK_POINTER_BITS	= 5;
	parameter STKPC_DSTACK_POINTER_MSB	= STKPC_DSTACK_POINTER_BITS-1;  
	
	// Return Stack  
	parameter STKPC_RSTACK_WIDTH 	 	= 16;
	parameter STKPC_RSTACK_SIZE 		= 32;
	parameter STKPC_RSTACK_MSB 			= STKPC_RSTACK_WIDTH -1;
	parameter STKPC_RSTACK_POINTER_BITS	= 5;
	parameter STKPC_RSTACK_POINTER_MSB	= STKPC_RSTACK_POINTER_BITS-1;  
	parameter STKPC_RSTACK_PC_MSB		= STKPC_RSTACK_MSB;
	parameter STKPC_RSTACK_PC_LSB		= 1;
	
	//MUXES
	
	//RETURN STACK MUX
	parameter STKPC_SEL_RSTACK_MSB 		= 1;
	parameter STKPC_SEL_RSTACK_PC 		= 0;
	parameter STKPC_SEL_RSTACK_ST0		= 1;
	parameter STKPC_SEL_RSTACK_PC_PLUS_1= 2;
	
	//NEW TOP OF STACK MUX (_ST0)
	parameter STKPC_SEL_ST0_NEW_MSB		= 1;
	parameter STKPC_SEL_ST0_NEW_ALU		= 0;
	parameter STKPC_SEL_ST0_NEW_RAM_IO	= 1;
	parameter STKPC_SEL_ST0_NEW_IMM		= 2;
	//PC MUX
	parameter STKPC_SEL_PC_MSB 		= 1;
	parameter STKPC_SEL_PC_COND_JMP	= 0;
	parameter STKPC_SEL_PC_INC 		= 1;
	parameter STKPC_SEL_PC_INSTR	= 2;
	parameter STKPC_SEL_PC_RSTACK	= 3;

	//ALU A MUX
	parameter STKPC_SEL_ALU_A_MSB 	= 1;
	parameter STKPC_SEL_ALU_A_ST0 	= 0;
	parameter STKPC_SEL_ALU_A_ST1	= 1;
	parameter STKPC_SEL_ALU_A_RST0	= 2;
	parameter STKPC_SEL_ALU_A_RSP	= 3;

	//ALU B MUX
	parameter STKPC_SEL_ALU_B_MSB 	= 1;
	parameter STKPC_SEL_ALU_B_ZERO 	= 0;
	parameter STKPC_SEL_ALU_B_ONES	= 1;
	parameter STKPC_SEL_ALU_B_ST0	= 2;
	parameter STKPC_SEL_ALU_B_DSP	= 3;

	//DSP MUX
	parameter STKPC_SEL_DSP_MSB 	= 1;
	parameter STKPC_SEL_DSP 		= 0;
	parameter STKPC_SEL_DSP_INC_1	= 1;
	parameter STKPC_SEL_DSP_INC_2	= 2;
	parameter STKPC_SEL_DSP_DEC_1	= 3;

	//RSP MUX
	parameter STKPC_SEL_RSP_MSB 	= 1;
	parameter STKPC_SEL_RSP 		= 0;
	parameter STKPC_SEL_RSP_INC_1	= 1;
	parameter STKPC_SEL_RSP_INC_2	= 2;
	parameter STKPC_SEL_RSP_DEC_1	= 3;

	//HALT Signal 
	parameter STKPC_FLOW_HALT_YES 	= 0;
	parameter STKPC_FLOW_HALT_NO	= 1;
	parameter STKPC_FLOW_HALT_BITS 	= 1;
	parameter STKPC_FLOW_HALT_MSB 	= 0;

	//Instruction Type Opcodes
	parameter STKPC_OPCODES_LIT 		= 'b1???????????????;
	parameter STKPC_OPCODES_JMP 		= 'b000?????????????;
	parameter STKPC_OPCODES_COND_JMP	= 'b001?????????????;
	parameter STKPC_OPCODES_CALL 		= 'b010?????????????;
	parameter STKPC_OPCODES_ALU 		= 'b011?????????????;
	//Instruction Opcodes
	parameter STKPC_OPCODES_NOP 		= 'b0110000000000000;
	parameter STKPC_OPCODES_HALT 		= 'b0110000000010000;
	parameter STKPC_OPCODES_NIP 		= 'b011?0000????0011;
	parameter STKPC_OPCODES_DUP 		= 'b011?00001???0001;
	parameter STKPC_OPCODES_RS_PUSH		= 'b011?0001?1??0111;
	parameter STKPC_OPCODES_SWAP 		= 'b011?00011???0000;
	parameter STKPC_OPCODES_OVER 		= 'b011?00011?????01;
	parameter STKPC_OPCODES_DROP 		= 'b011?0001000???11;
	parameter STKPC_OPCODES_MEM_WR 		= 'b011?0001001?0011;
	parameter STKPC_OPCODES_ADD 		= 'b011?0010??????11;
	parameter STKPC_OPCODES_AND 		= 'b011?0011????????;
	parameter STKPC_OPCODES_OR 			= 'b011?0100????????;
	parameter STKPC_OPCODES_XOR 		= 'b011?0101????????;
	parameter STKPC_OPCODES_INVERT 		= 'b011?0110????????;
	parameter STKPC_OPCODES_N_EQ_T 		= 'b011?0111????????;
	parameter STKPC_OPCODES_N_LT_T		= 'b011?1000????????;
	parameter STKPC_OPCODES_N_SR_T		= 'b011?1001????????;
	parameter STKPC_OPCODES_SUB1 		= 'b011?1010????????;
	parameter STKPC_OPCODES_RS_POP		= 'b011?101110??1101;
	parameter STKPC_OPCODES_RS_CP		= 'b011?101110??0001;
	parameter STKPC_OPCODES_T_ADDRESS 	= 'b011?1100????????;
	parameter STKPC_OPCODES_MEM_RD 		= 'b011?1100????????;
	parameter STKPC_OPCODES_N_SL_T 		= 'b011?1101????????;
	parameter STKPC_OPCODES_STK_DEP 	= 'b011?1110????????;
	parameter STKPC_OPCODES_N_ULT_T		= 'b011?1111????????;
	parameter STKPC_OPCODES_EXIT 		= 'b01110000????1100;

	//ALU Opcodes
	parameter STKPC_SEL_ALUOP_OR 	= 0;
	parameter STKPC_SEL_ALUOP_AND 	= 1;
	parameter STKPC_SEL_ALUOP_XOR	= 2;
	parameter STKPC_SEL_ALUOP_ADD 	= 3;
	parameter STKPC_SEL_ALUOP_NOT 	= 4;
	parameter STKPC_SEL_ALUOP_SRL 	= 5;
	parameter STKPC_SEL_ALUOP_SLL 	= 6;
	parameter STKPC_SEL_ALUOP_SLT 	= 7;
	parameter STKPC_SEL_ALUOP_SUB 	= 8;
	parameter STKPC_SEL_ALUOP_SLTU 	= 9;
	parameter STKPC_SEL_ALUOP_EQUAL	=10;
	parameter STKPC_SEL_ALUOP_SUB_1 =11;
	parameter STKPC_SEL_ALUOP_BITS 	= 4;
	parameter STKPC_SEL_ALUOP_MSB 	= 3;






