module adr_dec (/*AUTOARG*/
  // Outputs
  wb_cs,ram_cs,		
  
  // Inputs
  io_adr,clk_i,rst_i,io_rd,io_wr,ack_i
  );
  
`include "stkpc_params.v"

  //Outputs
  output					wb_cs;
  output					ram_cs;

  //Inputs

  input	[WB_ADR_O_MSB:0]	io_adr;	
  input						rst_i;
  input						clk_i;
  input						io_wr;
  input						io_rd;
  input 					ack_i;
  
	
  wire io_access;
  wire ram_access;
  assign io_access = (io_wr| io_rd)&(|io_adr[15:14]);
  assign ram_access =!(&io_adr[15:14]);
  

  reg					wb_cs;
  reg					ram_cs;
  reg					_wb_cs;
  reg					_ram_cs;
 /*
  
 always @(posedge clk_i) begin
		    if(rst_i==1'b1) begin
		      wb_cs <= 0;
		      ram_cs<=0;
		    end else if(io_access==1) begin		//If wb is the target
				wb_cs <= 1;
			end else if (ram_access==1) begin //if we are reading and slave is ready
				ram_cs<=1;
			  end else begin
			  wb_cs <= 0;
		      ram_cs<=0;
		    end
end*/

 always @(*) begin
			if(io_access==1&&ack_i==0) begin		//If wb is the target
				wb_cs <= 1;
			end else if (ram_access==1) begin //if we are reading and slave is ready
				ram_cs<=1;
			  end else begin
			  wb_cs <= 0;
		      ram_cs<=0;
		    end
end
  
endmodule // simd_STKPC_alu
/*  
 Local Variables:
 verilog-library-directories:(
 "."
 )
 End:
 */
