	module chip(/*AUTOARG*/
  // Outputs
  dat_o, adr_o, we_o, sel_o, stb_o, cyc_o,
  // Inputs
  clk, reset, cs
  );
	`include "stkpc_params.v"
	
		
	

	input    					clk;			//Clock	
	input						reset;			//Reset
	input     					cs; 			//top select
  // We need some outputs...
  
  output [WB_ADR_O_MSB:0]                                 adr_o;
  output [WB_DAT_O_MSB:0]                                 dat_o;
  output                                                  we_o;
  output [WB_SEL_O_MSB:0]                                 sel_o;
  output                                                  stb_o;
  output                                                  cyc_o;
  
	
	wire [WB_ADR_O_MSB:0] 		adr_o;
	wire [WB_DAT_O_MSB:0] 		dat_o;
	wire						we_o;
	wire [WB_SEL_O_MSB:0] 		sel_o;
	wire						stb_o;
	wire						cyc_o;
	wire						rst_i;
	wire						clk_i;
	wire	[WB_DAT_I_MSB:0] 	dat_i;	
	wire						ack_i;
	wire						err_i;
	wire						rty_i;		
	wire						cs;		
		
	cpu_top CPU_TOP (
		// Outputs
		.adr_o   			(adr_o),  	// Instructions read from ram
		.dat_o  			(dat_o),
		.we_o       		(we_o),  	// Instructions read from ram
		.sel_o       		(sel_o),  	// Instructions read from ram
		.stb_o     			(stb_o),  	// Instructions read from ram
		.cyc_o     			(cyc_o),  	// Instructions read from ram


		// Inputs
		.clk_i				(clk),                	// Clock     
		.rst_i     			(reset),               // We won't write to RAM
		.dat_i            	(dat_i),					//Always selected
		.ack_i            	(ack_i),
		.err_i     			(err_i),               // We won't write to RAM
		.rty_i          	(rty_i),					//Always selected            	//PC used as address      
		.cs             	(cs)
	 );               //We won't write to RAM
		
	peripheral_top PERIPHERAL_TOP (
            
		// Outputs
		.dat_o  			(dat_i),
		.ack_o       		(ack_i),  	// Instructions read from ram
		.rty_o       		(rty_i),  	// Instructions read from ram
		.err_o     		    (err_i),  	// Instructions read from ram

		// Inputs
		.clk_i        		(clk),                	// Clock     
		.rst_i     			(reset),               // We won't write to RAM
		.dat_i            	(dat_o),					//Always selected
		.adr_i             	(adr_o),
		.cyc_i             	(cyc_o),              	//PC used as address 
		.we_i	     		(we_o),               // We won't write to RAM
		.stb_i             	(stb_o),					//Always selected
		.sel_i		        (sel_o),
		.cs             	(cs)
	);   
	  
endmodule //chip
	
