module data_stack (
		// Outputs
		data_out,data_stack_0,
		data_stack_1,data_stack_2,data_stack_3,data_stack_4,data_stack_5,data_stack_6,
		data_stack_7,data_stack_8,		
		// Inputs
		data_in,addr_rd,addr_wr,rd_en,wr_en,clk
	);
  
	`include "stkpc_params.v"

	//Outputs
	output[STKPC_WORD_MSB:0] 		data_out;
	output 	[STKPC_DSTACK_MSB:0] data_stack_0;	//Signals to monitor content of data and return stack
	output 	[STKPC_DSTACK_MSB:0] data_stack_1;
	output 	[STKPC_DSTACK_MSB:0] data_stack_2;
	output 	[STKPC_DSTACK_MSB:0] data_stack_3;
	output 	[STKPC_DSTACK_MSB:0] data_stack_4;
	output 	[STKPC_DSTACK_MSB:0] data_stack_5;
	output 	[STKPC_DSTACK_MSB:0] data_stack_6;
	output 	[STKPC_DSTACK_MSB:0] data_stack_7;
	output 	[STKPC_DSTACK_MSB:0] data_stack_8;
	//Inputs
	input [STKPC_WORD_MSB:0] 		data_in; 
	input [STKPC_DSTACK_POINTER_MSB:0] 		addr_rd;
	input [STKPC_DSTACK_POINTER_MSB:0] 		addr_wr;
	input							rd_en;
	input							wr_en;
	input							clk;
	
	assign data_stack_0		= dstack[0];
	assign data_stack_1		= dstack[1];
	assign data_stack_2		= dstack[2];
	assign data_stack_3		= dstack[3];
	assign data_stack_4		= dstack[4];
	assign data_stack_5		= dstack[5];
	assign data_stack_6		= dstack[6];
	assign data_stack_7		= dstack[7];
	assign data_stack_8		= dstack[8];

		
	reg [STKPC_WORD_MSB:0] 		data_out;

	reg [STKPC_DSTACK_MSB:0]		dstack[0:STKPC_DSTACK_SIZE];	//Data stack


//update of data and return stack, pushing the top of stack 	
  always @(posedge clk /* or posedge reset*/) begin
    // if (reset!=1'b1) begin
      if (wr_en) begin
        dstack[addr_wr] = data_in;
      end  
    // end 
  end  
  always@(*) begin
	data_out<= dstack[addr_rd];
  end
  
  
endmodule // stkpc_alu

