	module peripheral_top (/*AUTOARG*/
		// Outputs
		dat_o, ack_o,err_o,rty_o,

		// Inputs
		rst_i,clk_i,dat_i,adr_i,cyc_i,we_i,stb_i,sel_i,cs
  );

	`include "stkpc_params.v"

	//Outputs
	output[WB_DAT_O_MSB:0] 	dat_o;
	output					ack_o;
	output				 	rty_o;
	output					err_o;

	//Inputs

	input						rst_i;
	input						clk_i;
	input	[WB_DAT_O_MSB:0] 	dat_i;	
	input	[WB_ADR_O_MSB:0]	adr_i;
	input						cyc_i;
	input						we_i;
	input						stb_i;	
	input	[WB_SEL_O_MSB:0]	sel_i;
	input						cs;		
   
	wb_s_16 WB_S_16 (

		 // Outputs
		 .dat_o  			(dat_o),
		 .ack_o       		(ack_o),  	// Instructions read from ram
		 .rty_o       		(rty_o),  	// Instructions read from ram
		 .err_o     		(err_o),  	// Instructions read from ram

		 // Inputs
		 .clk_i        		(clk_i),                	// Clock     
		 .rst_i     		(rst_i),               // We won't write to RAM
		 .dat_i            	(dat_i),					//Always selected
		 .adr_i             (adr_i),
		 .cyc_i             (cyc_i),              	//PC used as address 
		 .we_i	     		(we_i),               // We won't write to RAM
		 .stb_i             (stb_i),					//Always selected
		 .sel_i		        (sel_i),
		 .cs             	(cs)
	);   
	  
  
endmodule //peripheral_top
