module return_stack (
		// Outputs
		data_out,return_stack_0,return_stack_1,return_stack_2,		
		// Inputs
		data_in,addr_rd,addr_wr,rd_en,wr_en,clk
	);
  
	`include "stkpc_params.v"

	//Outputs
	output[STKPC_WORD_MSB:0] 		data_out;
	output	[STKPC_RSTACK_MSB:0] 	return_stack_0;
	output	[STKPC_RSTACK_MSB:0] 	return_stack_1;
	output	[STKPC_RSTACK_MSB:0] 	return_stack_2;
	//Inputs
	input [STKPC_WORD_MSB:0] 		data_in; 
	input [STKPC_WORD_MSB:0] 		addr_rd;
	input [STKPC_WORD_MSB:0] 		addr_wr;
	input							rd_en;
	input							wr_en;
	input							clk;

	assign return_stack_0	= rstack[0];
	assign return_stack_1	= rstack[1];
	assign return_stack_2	= rstack[2];

		
	reg [STKPC_WORD_MSB:0] 		data_out;

	reg [STKPC_RSTACK_MSB:0] 		rstack[0:STKPC_RSTACK_SIZE];	//Return stack

//update of data and return stack, pushing the top of stack 	
  always @(posedge clk /* or posedge reset*/) begin
    // if (reset!=1'b1) begin
      if (wr_en) begin
        rstack[addr_wr] = data_in;
      end  
    // end 
  end  
  always@(*) begin
	data_out<= rstack[addr_rd];
  end
  
  
endmodule // stkpc_alu

