	module wb_m_16 (
		// Outputs
		adr_o, dat_o, we_o, sel_o, stb_o, cyc_o,dat_i_cpu,		

		// Inputs
		rst_i,clk_i,dat_i,ack_i,err_i,rty_i,dat_o_cpu,adr_o_cpu, we_i_cpu,cs,io_access
	);
  
	`include "stkpc_params.v"

	//Outputs
	output[WB_ADR_O_MSB:0] 	adr_o;
	output[WB_DAT_O_MSB:0] 	dat_o;
	output					we_o;
	output[WB_SEL_O_MSB:0] 	sel_o;
	output					stb_o;
	output					cyc_o;
	output[WB_DAT_O_MSB:0] 	dat_i_cpu;

	//Inputs

	input						rst_i;
	input						clk_i;
	input	[WB_DAT_I_MSB:0] 	dat_i;	
	input						ack_i;
	input						err_i;
	input						rty_i;	
	input	[WB_DAT_O_MSB:0]	dat_o_cpu;
	input	[WB_ADR_O_MSB:0]	adr_o_cpu;	
	input						we_i_cpu;
	input						cs;		
	input 				    	io_access;		


	reg [WB_ADR_O_MSB:0] 	adr_o; 
	reg [WB_DAT_O_MSB:0] 	dat_o;
	reg						we_o;
	reg[WB_SEL_O_MSB:0] 	sel_o;
	reg						stb_o;
	reg						cyc_o;
	reg[WB_DAT_O_MSB:0] 	dat_i_cpu;
	wire					_io_access;
	assign _io_access = io_access|stb_o;

  //Every IO Access we update the data out, the address and write enable
	
	always @ (*) begin
		if (io_access ==1) begin
		adr_o <= adr_o_cpu;
		dat_o <= dat_o_cpu;

		end
	end
	
	//The data from the WB bus is passed to the CPU
	always @(*) begin
		dat_i_cpu<=dat_i;
	end
	
	always @ (*) begin
		if (io_access ==1 && we_i_cpu ==1) begin
			we_o <=we_i_cpu;
		end else if(io_access ==1 && we_i_cpu ==0) begin
			we_o <=we_i_cpu;
		end
	end
  
	always @(posedge clk_i ) begin
		if(rst_i==1'b1) begin
			stb_o <= 0;
			cyc_o <=0;
		end 
		else begin		
			if (io_access==1 && ack_i==0) begin //If slave is free, cycle start
				sel_o[0]<= 1;
				cyc_o <= 1;
				stb_o <=1;
			end else if ( ack_i==1) begin //If slave is done finish cycle
				//dat_i_cpu<= dat_i;
				stb_o <= 0;
				cyc_o <= 0;
			end 	      
		end
	end
	    
endmodule // wb_m_16

