#include  "dlx3_isa.H"
#include  "dlx3_isa_init.cpp"
#include  "dlx3_bhv_macros.H"


//!'using namespace' statement to allow access to all dlx3-specific datatypes

using namespace dlx3_parms;

//!Behavior executed before simulation begins.
void ac_behavior( begin ){
  npc = ac_pc + 4;
  for (int i = 0; i < 15; i ++)
    RB[i] = 0;
};

//!Behavior executed after simulation ends.
void ac_behavior( end ){
  for (int i = 0; i < 15; i+=4) {
    printf("r%02d=0x%08x ",i,RB[i]);
    printf("r%02d=0x%08x ",i+1,RB[i+1]);
    printf("r%02d=0x%08x ",i+2,RB[i+2]);
    printf("r%02d=0x%08x ",i+3,RB[i+3]);
    printf("\n");
  }
  printf("pc=0x%08x\n",(int)ac_pc);
};


//!Generic instruction behavior method.
void ac_behavior( instruction ){
  
  ac_pc = npc;
  npc = ac_pc + 4;


};


//! Instruction Format behavior methods.
void ac_behavior( Type_I ){}


int  ctm16_alu_op_add(int op1, int op2) {
  return op1 + op2;
}

int  ctm16_alu_op_sub(int op1, int op2 ) {
  return op1-op2;
}

void ac_behavior( add ) {
  RB[rd] = dlx3_alu_op_add( RB[rs1],RB[rs2] );

}


void ac_behavior( sub ) {
  RB[rd] = ctm16_alu_op_sub( RB[rs1],RB[rs2] );

}

